void main(int argc, char *argv[]) {
	
	int myrank, size;
	const int righeA = 10;
	const int colonneA = 15;
	const int righeB = 15;
	const int colonneB = 13;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank); /* Get my rank */
	MPI_Comm_size(MPI_COMM_WORLD, &size); /* Get the total number of processors */
	
	/*processo 0*/
	

	if (myrank==0) {
		int A[righeA][colonneA];
		int B[righeB][colonneB];
		int C[righeA][colonneB];
		int supporto[righeB];
		int i, j, k;
		int destinazione=1;

		srand(time(NULL));
				
		/*inizializzo A*/
		for (i = 0; i<righeA; i++) {
			for (j = 0; j<colonneA; j++) {
				A[i][j] = rand() % 20;
			}
		}
		/*inizializzo B*/
		for (i = 0; i<righeB; i++) {
			for (j = 0; j<colonneB; j++) {
				B[i][j] = rand() % 20;
			}
		}

		
		for(i = 0; i<righeA; i++) {
			for (j = 0; j<colonneB; j++) {
				
				MPI_Send(A[i], colonneA, MPI_INT, destinazione, 0, MPI_COMM_WORLD);
				for (k = 0; k < righeB; k++)
					supporto[k] = B[k][j];
				MPI_Send(supporto, righeB, MPI_INT, destinazione, 0, MPI_COMM_WORLD);
				destinazione++;
			}
		}
		for(k=0;k<(righeA*colonneB);k++) {
			i = k / colonneB;
			j = (k % colonneB);
			MPI_Recv(&C[i][j], 1, MPI_INT, k+1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		}
	}
	else {
		/*processo i*/
		int myresult = 0;
		int k;
		int riga[colonneA], colonna[righeB];

		MPI_Recv(riga, colonneA, MPI_INT, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		MPI_Recv(colonna, righeB, MPI_INT, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
		for (k = 0; k<colonneA; k++) 
			myresult += riga[k]*colonna[k];
		MPI_Send(&myresult, 1, MPI_INT, 0, 0, MPI_COMM_WORLD);
	
	}
				
	MPI_Finalize();
}